package pl.gda.pg.concurrency.atomicity;
import java.util.concurrent.atomic.AtomicInteger;

public class AtomicCounter {

    private int a = 0;
    public synchronized void increment() {
        a++;
    }

    public synchronized void decrement() {
        a--;
    }

    private AtomicInteger c = new AtomicInteger(0);

    private AtomicInteger d = new AtomicInteger(0);

    public void incrementAndGet() {
        int i = c.incrementAndGet(); //"++i"
        System.out.println("incrementAndGet: i=" + i);
        System.out.println("incrementAndGet: c=" + c);
    }

    public void getAndIncrement() {
        int i = d.getAndIncrement(); //i++
        System.out.println("getAndIncrement: i=" + i);
        System.out.println("getAndIncrement: d=" + d);
    }

    public int value() {
        return c.get();
    }

}